import * as React from "react";
import { Animated, ImageSourcePropType, StyleProp, ImageStyle } from "react-native";
import { ImageStyle as FastImageStyle, Source } from "react-native-fast-image";
export declare type CustomImageStyleProp = StyleProp<ImageStyle> | Array<StyleProp<ImageStyle>>;
export declare type CustomFastImageStyleProps = StyleProp<FastImageStyle> | Array<StyleProp<FastImageStyle>>;
export interface IProgressiveFastImageProps {
    loadingImageComponent?: React.ReactNode;
    source: Source;
    blurRadius: number;
    errorSource?: Source;
    loadingSource?: ImageSourcePropType;
    thumbnailSource?: ImageSourcePropType;
    style?: CustomFastImageStyleProps;
    loadingImageStyle?: CustomFastImageStyleProps;
    thumbnailAnimationDuration?: number;
    imageAnimationDuration?: number;
    useNativeDriver?: boolean;
}
interface IState {
    imageLoaded: boolean;
    error: boolean;
    showDefault: boolean;
}
declare class ProgressiveImage extends React.Component<IProgressiveFastImageProps, IState> {
    animatedImage: Animated.Value;
    animatedThumbnailImage: Animated.Value;
    animatedLoadingImage: Animated.Value;
    constructor(props: IProgressiveFastImageProps);
    onThumbnailLoad: () => void;
    onImageLoad: () => void;
    onLoadEnd: () => void;
    onError: () => void;
    normalisedSource: () => Source | null;
    statedSource: () => Source | null | undefined;
    render(): JSX.Element;
}
export default ProgressiveImage;
